// EE231002 Lab07. Magic Square
// 108061112, 林靖
// SIZEov. 2, 2019

#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define SIZE 3
#define UNFILLED 0
#define USED 0

typedef int BOOL;

int main(void)
{
	int i, j, k;
	int temp;
	int g_count;
	int max_integer;
	int num_of_unfilled;
	int g_array[SIZE + 1][SIZE + 1];
	int unfilled_row[SIZE * SIZE + 1];
	int unfilled_column[SIZE * SIZE + 1];
	int unused_integer[SIZE * SIZE + 1];
	int row, column;
	int g_target_sum;
	int sum;
	BOOL is_last_permutation;
	BOOL is_legal;
	
	max_integer = SIZE * SIZE;
	for (i = 1; i <= max_integer; i++) {
		unused_integer[i] = i;
	}

	num_of_unfilled = 0;
	for (i = 1; i <= SIZE; i++) {
		for (j = 1; j <= SIZE; j++) {
			scanf("%d", &g_array[i][j]);
//			g_array[i][j] = 0;
			if (g_array[i][j] == UNFILLED) {
				num_of_unfilled++;
				unfilled_row[num_of_unfilled] = i;
				unfilled_column[num_of_unfilled] = j;
			} else {
				unused_integer[g_array[i][j]] = USED;
			}
		}
	}

	for (i = 1; i <= max_integer; i++) {
		for (k = i; !unused_integer[k] && k <= max_integer; k++) ;
		unused_integer[i] = unused_integer[k];
		if (i != k) {
			unused_integer[k] = USED;
		}
	}

	g_target_sum = SIZE * (SIZE * SIZE + 1) / 2;

	g_count = 0;
	is_last_permutation = FALSE;
	while (!is_last_permutation) {

		for (i = 1; i <= num_of_unfilled; i++) {
			row = unfilled_row[i];
			column = unfilled_column[i];
			g_array[row][column] = unused_integer[i];
		}

		is_legal = TRUE;
		if (is_legal) {
			for (i = 1; i <= SIZE; i++) {
				sum = 0;
				for (j = 1; j <= SIZE; j++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			for (j = 1; j <= SIZE; j++) {
				sum = 0;
				for (i = 1; i <= SIZE; i++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 1, j = 1; i <= SIZE; i++, j++) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 1, j = SIZE; i <= SIZE; i++, j--) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			printf("Solution %d:\n", ++g_count);
			for (i = 1; i <= SIZE; i++) {
				for (j = 1; j <= SIZE; j++) {
					printf("%4d", g_array[i][j]);
				}
				printf("\n");
			}
			printf("\n");
		}
		for (j = num_of_unfilled - 1; j && unused_integer[j] > unused_integer[j + 1]; j--) ;
		if (!j) {
			is_last_permutation = TRUE;
		}
		for (k = num_of_unfilled; unused_integer[j] > unused_integer[k]; k--) ;
		temp = unused_integer[j];
		unused_integer[j] = unused_integer[k];
		unused_integer[k] = temp;
		k++;
		i = num_of_unfilled;
		while (k < i) { 
			temp = unused_integer[k];
			unused_integer[k] = unused_integer[i];
			unused_integer[i] = temp;
			k++;
			i--;
		}
	}
	printf("Number of solutions found: %d\n", g_count);
	return 0;	// Indicates normal program termination
}
